import gtk
import util

# a UI to a single action to be performed by clicking a button
class Action(object):
    def __init__(self, label, desc, impl, stock = None):
        (self.frame, self.vbox) = util.makeVBoxInFrame(desc)
        if label != None and stock != None:
            # use the given label and the given stock for the icon
            self.button = gtk.Button(label)
            image = gtk.Image()
            image.set_from_stock(stock, gtk.ICON_SIZE_MENU)
            self.button.set_property("image", image)
        else:
            self.button = gtk.Button(label, stock)
        self.button.connect("clicked", self.buttonClicked, None)
        self.impl = impl
        self.buttonHBox = gtk.HBox()
        self.buttonHBox.set_spacing(util.HSPACING)
        self.buttonHBox.pack_end(self.button, False, False)
        self.vbox.pack_start(self.buttonHBox, False, False, 0)
        
    def buttonClicked(self, button, param):
        assert param == None and button == self.button
        self.impl()

    def getWidget(self):
        return self.frame
    
    def setSensitive(self, sensitive):
        if sensitive:
            self.button.set_sensitive(True)
        else:
            self.button.set_sensitive(False)
            
