import gtk
import os.path
import os
import popen2
import errno

class DotRenderer(object):

    def __init__(self):
        self.renderCmd = "/usr/bin/neato"
        if not os.path.isfile(self.renderCmd):
            raise Exception(self.renderCmd + " does not exist.")
        

    def toPixbuf(self, dotFormat, sep):
        renderArgs = ["-Tsvg", "-Goverlap=scale", "-Gsep=%s" % str(sep)]
        bin = [self.renderCmd] + renderArgs
        child = popen2.Popen3(bin, True)
        toChild = child.tochild
        fromChild = child.fromchild
        fromChildError = child.childerr
        pid = child.pid
        
        toChild.write(dotFormat)
        toChild.flush()
        toChild.close()
        # this blocks the caller indefinitely until the renderer terminates
        # might need to change this to do it a bit more gracefully...
        keepReading = True
        svgFormat = ""

        # this read is sometimes interrupted by a signal. we wish to continue
        # reading when this occurs
        while True:
            try:
                svgFormat += fromChild.read()
                break
            except IOError, e:
                if e.errno != errno.EINTR:
                    raise

        os.waitpid(pid, 0)
    
        loader = gtk.gdk.PixbufLoader("svg")
        loader.write(svgFormat)
        loader.close()
        pixbuf = loader.get_pixbuf()
        return pixbuf
