import util
import pango, gtk

# a CounterExampleViewer for negative causation
class CounterExampleViewer(object):
    def __init__(self, cex):
	self.cex = cex

	# we presume only one witness
	assert cex.numExamples() == 1

	# we are really only interested in the second actor
	behaviour = cex.examples[0][1]

	# a trace of pairs (event, rightOnly), where rightOnly indicates if
	# this event was performed by the right-hand copy only
	trace = []

	leftEvent = None
	pingCount = 0
	refusedIndex = -1
	causedEvent = None
	index = 0
	for event in behaviour.trace:
	    if event.startswith("right_."):
                event = event.replace("right_.","",1)
	        assert pingCount < 1
		if leftEvent == None:
		    trace.append((event,True))
                else:
                    assert event == leftEvent
                    trace.append((event,False))
                    leftEvent = None
	    elif event.startswith("left_."):
                event = event.replace("left_.","",1)                
	        assert pingCount < 2
                if pingCount < 1:
                    assert leftEvent == None
                if leftEvent != None:
                    trace.append((leftEvent,False))
                leftEvent = event
	    elif event == "_tau":
	        # ignore it
                ()
	    else:
	        assert event == "ping_"
	        assert pingCount < 2
		assert leftEvent != None
		if pingCount == 0:
		    assert len(trace) > 0
		    refusedIndex = len(trace)
		    pingCount += 1
		else:
		    assert pingCount == 1
		    causedEvent = leftEvent
		    trace.append((leftEvent,False))
		    pingCount += 1
	    index += 1

	assert pingCount == 2
	assert refusedIndex != -1

	textview = gtk.TextView()
	textview.set_editable(False)
	textview.set_wrap_mode(gtk.WRAP_NONE)
	textview.set_left_margin(util.BORDER_WIDTH)
	textview.modify_font(pango.FontDescription("Monospace"))
	textbuffer = textview.get_buffer()
	text = ("Event being caused to not occur: %s\n" % causedEvent + 
		"Behaviour:\n")
	for index in range(len(trace)):
	    text += "%s %s %s\n" % (trace[index][0], 
                                   ("","(causing)")[trace[index][1]],
				   ("","(refused)")[index == refusedIndex])
	textbuffer.set_text(text)
	textview.show()
	self.widget = textview
        
    def getWidget(self):
	return self.widget
