import util
import pango, gtk

# a CounterExampleViewer for acquirable permissions
class CounterExampleViewer(object):
    def __init__(self, cex):
	self.cex = cex

	# we presume only one witness
	assert cex.numExamples() == 1

	# we are really only interested in the second actor
	behaviour = cex.examples[0][1]

	# a trace of pairs (event, leftOnly), where leftOnly indicates if
	# this event was performed by the left-hand copy only
	trace = []
	for event in behaviour.trace:
	    if event != "_tau":
                trace.append(event)

        assert len(trace) >= 1
        permEvent = trace[len(trace)-1]
        
	textview = gtk.TextView()
	textview.set_editable(False)
	textview.set_wrap_mode(gtk.WRAP_NONE)
	textview.set_left_margin(util.BORDER_WIDTH)
	textview.modify_font(pango.FontDescription("Monospace"))
	textbuffer = textview.get_buffer()
	text = ("Event being performed: %s\n" % permEvent + 
		"Behaviour:\n")
	for event in trace:
	    text += "%s\n" % event

	textbuffer.set_text(text)
	textview.show()
	self.widget = textview
        
    def getWidget(self):
	return self.widget
