import gtk
# utility functions

STOCK_EXPLORE = gtk.STOCK_EXECUTE
STOCK_CHECK = gtk.STOCK_SPELL_CHECK

# render the sequence, using the given seperator between elements, as a string
def seqString(seq, sep):
    ss = ""
    ll = len(seq)
    ii = 0
    while (ii < ll):
        ss += str(seq[ii])
        ii += 1
        if ii != ll:
            ss += sep
    return ss


# return a string that is 'cmd' with an end of line character at the end
# if it didn't have one already
def eolTerminate(cmd):
    if cmd[len(cmd)-1] != "\n":
        cmd += "\n"
    return cmd



VSPACING = 15
HSPACING = 5
BORDER_WIDTH = 10


def makeVBoxInFrame(name, desc = None):
    frame = gtk.Frame(name)
    vbox = gtk.VBox()
    vbox.set_border_width(BORDER_WIDTH)
    vbox.set_spacing(VSPACING)
    frame.add(vbox)
    if desc != None:
        label = gtk.Label(desc)
        # left-align the label by using an hbox
        labelHBox = gtk.HBox()
        labelHBox.pack_start(label, False, False, 0)
        vbox.pack_start(labelHBox, False, True, 0)
        
    return (frame, vbox)
